//Solution for Exercise 6
// Compile with: gcc -O0 -fopenmp -o RAMpattern RAMpattern.c && ./RAMpattern
#include <stdio.h>
#include <time.h>
#include <sys/time.h>
#ifdef _OPENMP
#  include <omp.h>
#endif

#define ROWS 100000
#define COLS 100000

int main() {
  int i;
  double w, x, sum;
  int a[ROWS][COLS];
  
  //Variables for timing single core
  clock_t t1,t2;
  struct timeval tv1,tv2; 
  struct timezone tz;

# ifdef _OPENMP
    double wt1,wt2; //For Timing with OpenMP
# endif
 
# ifdef _OPENMP
#   pragma omp parallel
    { 
#     pragma omp single 
      printf("OpenMP-parallel with %1d threads\n", omp_get_num_threads());
    } /* end omp parallel */
# endif

/* do the work */
  sum = 0;
  int row, col;


  //Do Start of Timing
  gettimeofday(&tv1, &tz);
# ifdef _OPENMP
    wt1 = omp_get_wtime();
# endif
  t1 = clock();

/* do the work */
  sum = 0;
  int b;

  for (row = 0; row<ROWS; row+=8) {
    for (col =0; col<COLS; col+=8) {
      b = a[row][col];
      __asm__ __volatile__ ("");
    }
  }

/* work end */

  //Do End of Timing
  t2 = clock();
# ifdef _OPENMP
    wt2 = omp_get_wtime();
# endif
  gettimeofday(&tv2, &tz);
  printf("computed sum = %24.16g\n", sum);
  printf("CPU time (clock)                = %12.4g sec\n", (t2-t1)/1000000.);
# ifdef _OPENMP
    printf("wall clock time (omp_get_wtime) = %12.4g sec\n", wt2-wt1);
# endif
  printf("wall clock time (gettimeofday)  = %12.4g sec\n", (tv2.tv_sec-tv1.tv_sec) + (tv2.tv_usec-tv1.tv_usec)*1e-6 );



// WRONG

  //Do Start of Timing
  gettimeofday(&tv1, &tz);
# ifdef _OPENMP
    wt1 = omp_get_wtime();
# endif
  t1 = clock();

/* do the work */
  sum = 0;

  for (col =0; col<COLS; col+=8) {
    for (row = 0; row<ROWS; row+=8) {
      b = a[row][col];
      __asm__ __volatile__ ("");
    }
  }

/* work end */

  //Do End of Timing
  t2 = clock();
# ifdef _OPENMP
    wt2 = omp_get_wtime();
# endif
  gettimeofday(&tv2, &tz);
  printf("computed sum = %24.16g\n", sum);
  printf("CPU time (clock)                = %12.4g sec\n", (t2-t1)/1000000.);
# ifdef _OPENMP
    printf("wall clock time (omp_get_wtime) = %12.4g sec\n", wt2-wt1);
# endif
  printf("wall clock time (gettimeofday)  = %12.4g sec\n", (tv2.tv_sec-tv1.tv_sec) + (tv2.tv_usec-tv1.tv_usec)*1e-6 );




}